Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

## javax.servlet.annotation
Annotation Type HttpMethodConstraint

    @Documented
    @Retention(value=RUNTIME)
    public @interface HttpMethodConstraint

This annotation is used within the `ServletSecurity` annotation to represent security constraints on specific HTTP protocol messages.

Since:
  Servlet 3.0

Required Element Summary
`java.lang.String` | `value` Http protocol method name

Optional Element Summary
`ServletSecurity.EmptyRoleSemantic` | `emptyRoleSemantic` The default authorization semantic.
`java.lang.String[]` | `rolesAllowed` The names of the authorized roles.
`ServletSecurity.TransportGuarantee` | `transportGuarantee` The data protection requirements (i.e., whether or not SSL/TLS is required) that must be satisfied by the connections on which requests arrive.

Element Detail

### value

    public abstract java.lang.String value

  Http protocol method name

  Returns:
    the name of an HTTP protocol method. `value` may not be null, or the empty string, and must be a legitimate HTTP Method name as defined by RFC 2616.

### emptyRoleSemantic

    public abstract ServletSecurity.EmptyRoleSemantic emptyRoleSemantic

  The default authorization semantic. This value is insignificant when `rolesAllowed` returns a non-empty array, and should not be specified when a non-empty array is specified for `rolesAllowed`.

  Returns:
    the `ServletSecurity.EmptyRoleSemantic` to be applied when `rolesAllowed` returns an empty (that is, zero-length) array.
  Default:
    javax.servlet.annotation.ServletSecurity.EmptyRoleSemantic.PERMIT

### transportGuarantee

    public abstract ServletSecurity.TransportGuarantee transportGuarantee

  The data protection requirements (i.e., whether or not SSL/TLS is required) that must be satisfied by the connections on which requests arrive.

  Returns:
    the `ServletSecurity.TransportGuarantee` indicating the data protection that must be provided by the connection.
  Default:
    javax.servlet.annotation.ServletSecurity.TransportGuarantee.NONE

### rolesAllowed

    public abstract java.lang.String[] rolesAllowed

  The names of the authorized roles. Duplicate role names appearing in rolesAllowed are insignificant and may be discarded during runtime processing of the annotation. The String `"*"` has no special meaning as a role name (should it occur in rolesAllowed).

  Returns:
    an array of zero or more role names. When the array contains zero elements, its meaning depends on the value returned by `emptyRoleSemantic`. If `emptyRoleSemantic` returns `DENY`, and `rolesAllowed` returns a zero length array, access is to be denied independent of authentication state and identity. Conversely, if `emptyRoleSemantic` returns `PERMIT`, it indicates that access is to be allowed independent of authentication state and identity. When the array contains the names of one or more roles, it indicates that access is contingent on membership in at least one of the named roles (independent of the value returned by `emptyRoleSemantic`).
  Default:
    {}

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: REQUIRED | OPTIONAL | DETAIL: ELEMENT

Copyright © 1995-2010 Mort Bay Consulting. All Rights Reserved.